#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("blank vector") {
    double min = 0;
    double max = 0;
    find_minmax({NULL}, min, max);
    CHECK(min == 0);
    CHECK(max == 0);
}

TEST_CASE("one element vector"){
    double min = 0;
    double max = 0;
    find_minmax({5}, min, max);
    CHECK(min == 5);
    CHECK(max == 5);
}

TEST_CASE("negative elements vector"){
    double min = 0;
    double max = 0;
    find_minmax({-3, -7, -24}, min, max);
    CHECK(min == -24);
    CHECK(max == -3);
}

TEST_CASE("same elements vector"){
    double min = 0;
    double max = 0;
    find_minmax({8, 8, 8}, min, max);
    CHECK(min == 8);
    CHECK(max == 8);
}

